<?xml version="1.0" encoding="UTF-8" ?>
<!-- 
  (c) Copyright 2009, Christopher Cormack

  This Software is licensed to You, the licensee, for use under the terms of   
  the 1060 Public License v1.0. Please read and agree to the 1060 Public       
  License v1.0 [www.1060research.com/license] before using or redistributing   
  this software.                                                               

  In summary the 1060 Public license has the following conditions.             
  A. You may use the Software free of charge provided you agree to the terms   
  laid out in the 1060 Public License v1.0                                     
  B. You are only permitted to use the Software with components or applications
  that provide you with OSI Certified Open Source Code [www.opensource.org], or
  for which licensing has been approved by 1060 Research Limited.              
  You may write your own software for execution by this Software provided any  
  distribution of your software with this Software complies with terms set out 
  in section 2 of the 1060 Public License v1.0                                 
  C. You may redistribute the Software provided you comply with the terms of   
  the 1060 Public License v1.0 and that no warranty is implied or given.       
  D. If you find you are unable to comply with this license you may seek to    
  obtain an alternative license from 1060 Research Limited by contacting       
  license@1060research.com or by visiting www.1060research.com                 

  NO WARRANTY:  THIS SOFTWARE IS NOT COVERED BY ANY WARRANTY. SEE 1060 PUBLIC  
  LICENSE V1.0 FOR DETAILS                                                     

  THIS COPYRIGHT NOTICE IS *NOT* THE 1060 PUBLIC LICENSE v1.0. PLEASE READ     
  THE DISTRIBUTED 1060_Public_License.txt OR www.1060research.com/license      

  $Id$
-->
<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns="http://www.w3.org/1999/xhtml">
  <xsl:param name="config"/>

  <xsl:template match="/resultset">
    <ul id="{$config/config/list/id}">
      <xsl:attribute name="class"><xsl:value-of select="$config/config/list/class"/></xsl:attribute>
      <xsl:for-each select="row">
        <xsl:variable name="currentRowChildren" select="child::node()"/>
        <xsl:variable name="include">
          <xsl:for-each select="$config/config/filters/filter">
            <xsl:variable name="currentFilter" select="."/>
            <xsl:choose>
              <xsl:when test="value[@type='not']">
                <xsl:if test="$currentRowChildren[local-name()=$currentFilter/datafield]=value"> no
                </xsl:if>
              </xsl:when>
              <xsl:otherwise>
                <xsl:if test="$currentRowChildren[local-name()=$currentFilter/datafield]!=value"> no
                </xsl:if>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:for-each>
        </xsl:variable>
        <xsl:if test="not(contains($include,'no'))">
          <li>
            <input type="checkbox">
              <xsl:apply-templates select="$config/config/item/name">
                <xsl:with-param name="current-row" select="."/>
              </xsl:apply-templates>
              <xsl:apply-templates select="$config/config/item/id">
                <xsl:with-param name="current-row" select="."/>
              </xsl:apply-templates>
              <xsl:apply-templates select="$config/config/item/class">
                <xsl:with-param name="current-row" select="."/>
              </xsl:apply-templates>
            </input>&#160;<span>
              <xsl:apply-templates select="$config/config/item/text/*">
                <xsl:with-param name="current-row" select="."/>
              </xsl:apply-templates>
            </span>
          </li>
        </xsl:if>
      </xsl:for-each>
    </ul>
  </xsl:template>
  
  <xsl:template match="config/item/name | config/item/id | config/item/class">
    <xsl:param name="current-row"/>
    <xsl:attribute name="{local-name()}">
      <xsl:apply-templates select="*">
        <xsl:with-param name="current-row" select="$current-row"/>
      </xsl:apply-templates>
    </xsl:attribute>
  </xsl:template>
  
  <xsl:template match="datafield">
    <xsl:param name="current-row"/>
    <xsl:variable name="name" select="text()"/>
    <xsl:value-of select="$current-row//*[local-name()=$name]"/>
  </xsl:template>
  
  <xsl:template match="string">
    <xsl:apply-templates select="node()"/>
  </xsl:template>
  
  <xsl:template match="/null">
    <ul id="{$config/config/id}">
      <li>There are no entries available</li>
    </ul>
  </xsl:template>
</xsl:stylesheet>
